import { JSX } from 'react';
import type { TAsyncLocaleDataProps } from '@commercetools-frontend/i18n';
type RenderFnArgs = {
    isAuthenticated: boolean;
};
export type TAuthenticatedProps = {
    render: (args: RenderFnArgs) => JSX.Element;
    locale: string;
    applicationMessages: TAsyncLocaleDataProps['applicationMessages'];
    children?: never;
};
declare const AuthenticationRoutes: {
    (props: TAuthenticatedProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default AuthenticationRoutes;
