import { type ReactNode } from 'react';
import { ApolloClient, type NormalizedCacheObject } from '@apollo/client';
import { type TAsyncLocaleDataProps } from '@commercetools-frontend/i18n';
type TCustomViewShellProps = {
    apolloClient?: ApolloClient<NormalizedCacheObject>;
    applicationMessages: TAsyncLocaleDataProps['applicationMessages'];
    disableDevHost?: boolean;
    enableReactStrictMode?: boolean;
    children: ReactNode;
};
declare const CustomViewShellWrapper: (props: TCustomViewShellProps) => import("@emotion/react/jsx-runtime").JSX.Element;
export default CustomViewShellWrapper;
