import { ReactNode } from 'react';
import type { TFlags } from '@flopflip/types';
import type { TFetchLoggedInUserQuery } from '../../types/generated/mc';
type TSetupFlopFlipProviderProps = {
    projectKey?: string;
    user?: TFetchLoggedInUserQuery['user'];
    flags?: TFlags;
    defaultFlags?: TFlags;
    ldClientSideId?: string;
    children: ReactNode;
    shouldDeferAdapterConfiguration?: boolean;
};
export declare const SetupFlopFlipProvider: {
    (props: TSetupFlopFlipProviderProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default SetupFlopFlipProvider;
