import { type ReactNode } from 'react';
import { type RouteProps } from 'react-router-dom';
type TSuspendedRouteProps = Omit<RouteProps, 'children'> & {
    children: ReactNode;
};
declare const SuspendedRoute: {
    (props: TSuspendedRouteProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default SuspendedRoute;
