'use strict';

var _slicedToArray = require('@babel/runtime-corejs3/helpers/slicedToArray');
var _defineProperty = require('@babel/runtime-corejs3/helpers/defineProperty');
var _mapInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/map');
var _findInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/find');
var _Object$keys = require('@babel/runtime-corejs3/core-js-stable/object/keys');
var _Object$getOwnPropertySymbols = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols');
var _filterInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/filter');
var _Object$getOwnPropertyDescriptor = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor');
var _forEachInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/for-each');
var _Object$getOwnPropertyDescriptors = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors');
var _Object$defineProperties = require('@babel/runtime-corejs3/core-js-stable/object/define-properties');
var _Object$defineProperty = require('@babel/runtime-corejs3/core-js-stable/object/define-property');
var react = require('react');
var client = require('@apollo/client');
var applicationShellConnectors = require('@commercetools-frontend/application-shell-connectors');
var l10n = require('@commercetools-frontend/l10n');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var _mapInstanceProperty__default = /*#__PURE__*/_interopDefault(_mapInstanceProperty);
var _findInstanceProperty__default = /*#__PURE__*/_interopDefault(_findInstanceProperty);
var _Object$keys__default = /*#__PURE__*/_interopDefault(_Object$keys);
var _Object$getOwnPropertySymbols__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertySymbols);
var _filterInstanceProperty__default = /*#__PURE__*/_interopDefault(_filterInstanceProperty);
var _Object$getOwnPropertyDescriptor__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptor);
var _forEachInstanceProperty__default = /*#__PURE__*/_interopDefault(_forEachInstanceProperty);
var _Object$getOwnPropertyDescriptors__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptors);
var _Object$defineProperties__default = /*#__PURE__*/_interopDefault(_Object$defineProperties);
var _Object$defineProperty__default = /*#__PURE__*/_interopDefault(_Object$defineProperty);

function ownKeys(e, r) { var t = _Object$keys__default["default"](e); if (_Object$getOwnPropertySymbols__default["default"]) { var o = _Object$getOwnPropertySymbols__default["default"](e); r && (o = _filterInstanceProperty__default["default"](o).call(o, function (r) { return _Object$getOwnPropertyDescriptor__default["default"](e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var _context3, _context4; var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? _forEachInstanceProperty__default["default"](_context3 = ownKeys(Object(t), !0)).call(_context3, function (r) { _defineProperty(e, r, t[r]); }) : _Object$getOwnPropertyDescriptors__default["default"] ? _Object$defineProperties__default["default"](e, _Object$getOwnPropertyDescriptors__default["default"](t)) : _forEachInstanceProperty__default["default"](_context4 = ownKeys(Object(t))).call(_context4, function (r) { _Object$defineProperty__default["default"](e, r, _Object$getOwnPropertyDescriptor__default["default"](t, r)); }); } return e; }
var FetchApplicationsMenu = { kind: "Document", definitions: [{ kind: "OperationDefinition", operation: "query", name: { kind: "Name", value: "FetchApplicationsMenu" }, variableDefinitions: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "applicationsMenu" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "appBar" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "key" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "uriPath" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "labelAllLocales" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "locale" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "value" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "featureToggle" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "permissions" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "navBarGroups" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "key" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "items" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "key" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "uriPath" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "icon" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "labelAllLocales" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "locale" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "value" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "featureToggle" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "menuVisibility" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "permissions" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "actionRights" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "group" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "name" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "dataFences" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "group" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "name" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "type" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "submenu" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "key" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "uriPath" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "labelAllLocales" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "locale" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "value" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "featureToggle" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "menuVisibility" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "permissions" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "actionRights" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "group" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "name" }, arguments: [], directives: [] }] } }, { kind: "Field", name: { kind: "Name", value: "dataFences" }, arguments: [], directives: [], selectionSet: { kind: "SelectionSet", selections: [{ kind: "Field", name: { kind: "Name", value: "group" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "name" }, arguments: [], directives: [] }, { kind: "Field", name: { kind: "Name", value: "type" }, arguments: [], directives: [] }] } }] } }] } }] } }] } }] } }], loc: { start: 0, end: 939, source: { body: "query FetchApplicationsMenu {\n  applicationsMenu {\n    appBar {\n      key\n      uriPath\n      labelAllLocales {\n        locale\n        value\n      }\n      featureToggle\n      permissions\n    }\n    navBarGroups {\n      key\n      items {\n        key\n        uriPath\n        icon\n        labelAllLocales {\n          locale\n          value\n        }\n        featureToggle\n        menuVisibility\n        permissions\n        actionRights {\n          group\n          name\n        }\n        dataFences {\n          group\n          name\n          type\n        }\n        submenu {\n          key\n          uriPath\n          labelAllLocales {\n            locale\n            value\n          }\n          featureToggle\n          menuVisibility\n          permissions\n          actionRights {\n            group\n            name\n          }\n          dataFences {\n            group\n            name\n            type\n          }\n        }\n      }\n    }\n  }\n}\n", name: "GraphQL request", locationOffset: { line: 1, column: 1 } } } };
const defaultApiUrl = window.location.origin;
const mapLabelAllLocalesWithDefaults = (labelAllLocales, defaultLabel) => {
  let mappedLabelAllLocales = labelAllLocales;
  if (defaultLabel) {
    var _context;
    // Map all supported locales with the given localized labels.
    // If a locale is not defined in the config, we use the `default` label as the value.
    // This is only needed for development as we're trying to map two different schemas.
    mappedLabelAllLocales = _mapInstanceProperty__default["default"](_context = l10n.getSupportedLocales()).call(_context, supportedLocale => {
      const existingField = _findInstanceProperty__default["default"](labelAllLocales).call(labelAllLocales, field => field.locale === supportedLocale);
      if (existingField) return existingField;
      return {
        locale: supportedLocale,
        value: defaultLabel
      };
    });
  }

  // Add the `__typename`.
  return _mapInstanceProperty__default["default"](mappedLabelAllLocales).call(mappedLabelAllLocales, field => _objectSpread({
    __typename: 'LocalizedField'
  }, field));
};
/**
 * Transform menu links defined in the `custom-application-config.json` to the `FetchApplicationsMenu` schema.
 * This is only needed for development.
 */
const mapApplicationMenuConfigToGraqhQLQueryResult = applicationConfig => {
  var _context2;
  const entryPointUriPath = applicationConfig.entryPointUriPath;
  const menuLinks = applicationConfig.__DEVELOPMENT__?.menuLinks;
  // @ts-expect-error: the `accountLinks` is not explicitly typed as it's only used by the account app.
  const accountLinks = applicationConfig.__DEVELOPMENT__?.accountLinks ?? [];
  return {
    applicationsMenu: {
      __typename: 'ApplicationsMenu',
      navBarGroups: menuLinks ? [{
        // for development, the navBarGroup key is set to '2' since all Custom Applications belong to the second Navbar group.
        key: '2',
        items: [{
          __typename: 'NavbarMenu',
          key: entryPointUriPath,
          uriPath: entryPointUriPath,
          icon: menuLinks.icon,
          labelAllLocales: mapLabelAllLocalesWithDefaults(menuLinks.labelAllLocales, menuLinks.defaultLabel),
          permissions: menuLinks.permissions,
          // @ts-ignore: not defined in schema, as it's only used internally.
          featureToggle: menuLinks.featureToggle ?? null,
          // @ts-ignore: not defined in schema, as it's only used internally.
          menuVisibility: menuLinks.menuVisibility ?? null,
          // @ts-ignore: not defined in schema, as it's only used internally.
          actionRights: menuLinks.actionRights ?? null,
          // @ts-ignore: not defined in schema, as it's only used internally.
          dataFences: menuLinks.dataFences ?? null,
          submenu: _mapInstanceProperty__default["default"](_context2 = menuLinks.submenuLinks).call(_context2, submenuLink => ({
            __typename: 'BaseMenu',
            key: `${entryPointUriPath}-${submenuLink.uriPath}`,
            uriPath: submenuLink.uriPath,
            labelAllLocales: mapLabelAllLocalesWithDefaults(submenuLink.labelAllLocales, submenuLink.defaultLabel),
            permissions: submenuLink.permissions,
            // @ts-ignore: not defined in schema, as it's only used internally.
            featureToggle: submenuLink.featureToggle ?? null,
            // @ts-ignore: not defined in schema, as it's only used internally.
            menuVisibility: submenuLink.menuVisibility ?? null,
            // @ts-ignore: not defined in schema, as it's only used internally.
            actionRights: submenuLink.actionRights ?? null,
            // @ts-ignore: not defined in schema, as it's only used internally.
            dataFences: submenuLink.dataFences ?? null
          }))
        }]
      }] : [],
      appBar: _mapInstanceProperty__default["default"](accountLinks).call(accountLinks, menuLink => ({
        __typename: 'BaseMenu',
        key: menuLink.uriPath,
        uriPath: menuLink.uriPath,
        labelAllLocales: mapLabelAllLocalesWithDefaults(menuLink.labelAllLocales, menuLink.defaultLabel),
        permissions: menuLink.permissions,
        // @ts-ignore: not defined in schema, as it's only used internally.
        featureToggle: menuLink.featureToggle ?? null
      }))
    }
  };
};
function useApplicationsMenu(menuKey, config) {
  const apolloClient = client.useApolloClient();
  const mcProxyApiUrl = applicationShellConnectors.useApplicationContext(context => context.environment.mcProxyApiUrl);
  const _useState = react.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    hasWrittenToCache = _useState2[0],
    setHasWrittenToCache = _useState2[1];

  // Fetch all menu links from the GraphQL API in the Merchant Center Proxy.
  // For local development, we don't fetch data from the remote server but use
  // only the configuration for the menu links defined for the application.
  // To do so, we manually write the data in the Apollo cache and use the
  // `fetchPolicy: cache-only` to instruct Apollo to read the data from the cache.
  // NOTE: In development, we skip the query as long as the data hasn't been written
  // into the cache. If not, Apollo throws an error like
  // `Can't find field 'applicationMenu' on ROOT_QUERY object`.
  const _useMcQuery = applicationShellConnectors.useMcQuery(FetchApplicationsMenu, {
      skip: config.environment.servedByProxy ?
      // Production environment
      false :
      // Development environment
      !hasWrittenToCache,
      fetchPolicy: config.environment.servedByProxy ? 'cache-first' : 'cache-only',
      context: {
        // Allow to overwrite the API url from application config
        uri: `${mcProxyApiUrl || defaultApiUrl}/api/graphql`,
        skipGraphQlTargetCheck: true
      }
    }),
    menuQueryResult = _useMcQuery.data;

  // For development, we read the menu data from the configuration file and
  // write it into the Apollo cache.
  react.useEffect(() => {
    if (config.environment.__DEVELOPMENT__ && (config.environment.__DEVELOPMENT__.menuLinks ||
    // @ts-expect-error: the `accountLinks` is not explicitly typed as it's only used by the account app.
    config.environment.__DEVELOPMENT__.accountLinks) && !hasWrittenToCache) {
      const applicationMenu = mapApplicationMenuConfigToGraqhQLQueryResult(config.environment);
      apolloClient.writeQuery({
        query: FetchApplicationsMenu,
        data: applicationMenu
      });
      setHasWrittenToCache(true);
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [hasWrittenToCache]); // Only subscribe to state changes.

  if (menuQueryResult && menuQueryResult.applicationsMenu) {
    return menuQueryResult.applicationsMenu[menuKey];
  }
  return;
}

exports.useApplicationsMenu = useApplicationsMenu;
