import { ReactNode } from 'react';
import type { ApolloError } from '@apollo/client/errors';
import type { TFetchProjectQuery } from '../../types/generated/mc';
type RenderFnArgs = {
    isLoading: boolean;
    error?: ApolloError;
    project: TFetchProjectQuery['project'];
};
type TFetchProjectProps = {
    projectKey?: string;
    skip?: boolean;
    children: (args: RenderFnArgs) => ReactNode;
};
declare const FetchProject: {
    (props: TFetchProjectProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default FetchProject;
