import type { Command, SearchText, HistoryEntry } from '../types';
type Props = {
    historyEntries: HistoryEntry[];
    onHistoryEntriesChange: (historyEntries: HistoryEntry[]) => void;
    search: (searchText: SearchText) => Promise<Command[]>;
    getNextCommands: (command: Command) => Promise<Command[]>;
    executeCommand: (command: Command, meta: {
        openInNewTab: boolean;
    }) => void;
    onClose: () => void;
    classNameShakeAnimation: string;
};
declare const ButlerWithAnimation: (props: Omit<Props, 'classNameShakeAnimation'>) => import("@emotion/react/jsx-runtime").JSX.Element;
export default ButlerWithAnimation;
